commit cda1472944648652764c6980f5ee3f3e91459ef3
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Oct 28 11:15:03 2019 +0100

    Major SSSP overhaul:
    - SSSP no works even without Bootloader (AMiRo-OS implements startup and shutdown phases)
    - MSI and calendar synchronization are currently not available (WIP)
    - lots of minor changes

diff --git a/amiroos.h b/amiroos.h
index 251d8d2..9e1a090 100644
--- a/amiroos.h
+++ b/amiroos.h
@@ -45,21 +45,32 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   The operating system minor version.
  * @note    A higher minor version implies new functionalty, but all old interfaces are still available.
  */
-#define AMIROOS_VERSION_MINOR         0
+#define AMIROOS_VERSION_MINOR         1
 
 /**
  * @brief   The operating system patch level.
  */
-#define AMIROOS_VERSION_PATCH         1
+#define AMIROOS_VERSION_PATCH         0
 
 /** @} */
 
 /******************************************************************************/
+/* CONFIGURATION                                                              */
+/******************************************************************************/
+
+#include <aosconf.h>
+#if !defined(_AMIRO_OS_CFG_)
+#error "invalid AMiRo-OS configuration file"
+#elif (AMIRO_OS_CFG_VERSION_MAJOR != AMIROOS_VERSION_MAJOR) || (AMIRO_OS_CFG_VERSION_MINOR < AMIROOS_VERSION_MINOR)
+#error "incompatible AMiRo-OS configuration file"
+#endif
+
+/******************************************************************************/
 /* SUBSYSTEMS                                                                 */
 /******************************************************************************/
 
-/* Bootloader (AMiRo-BLT) */
-#include <amiroblt.h>
+/* Bootloader */
+#include <aos_bootloader.h>
 
 /* System Kerne (ChibiOS)l */
 #include <hal.h>
@@ -72,27 +83,23 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /* AMiRo-OS CORE                                                              */
 /******************************************************************************/
 
-/* configuration */
-#include <aosconf.h>
-#if !defined(_AMIRO_OS_CFG_)
-#error "invalid AMiRo-OS configuration file"
-#elif (AMIRO_OS_CFG_VERSION_MAJOR != AMIROOS_VERSION_MAJOR) || (AMIRO_OS_CFG_VERSION_MINOR < AMIROOS_VERSION_MINOR)
-#error "incompatible AMiRo-OS configuration file"
-#endif
 #include "core/inc/aos_confcheck.h"
 
-/* core headers */
 #include "core/inc/aos_types.h"
 #include "core/inc/aos_debug.h"
 #include "core/inc/aos_time.h"
 #include "core/inc/aos_timer.h"
 #include "core/inc/aos_iostream.h"
 #include "core/inc/aos_shell.h"
+#include "core/inc/aos_sssp.h"
 #include "core/inc/aos_system.h"
 #include "core/inc/aos_thread.h"
 #include "core/inc/aos_test.h"
 
-/* module specifications */
+/******************************************************************************/
+/* MODULE                                                                     */
+/******************************************************************************/
+
 #include <module.h>
 
 #endif /* AMIROOS_H */
diff --git a/bootloader/aos_bootloader.h b/bootloader/aos_bootloader.h
new file mode 100644
index 0000000..b18c5b2
--- /dev/null
+++ b/bootloader/aos_bootloader.h
@@ -0,0 +1,82 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+/**
+ * @file    aos_bootloader.h
+ * @brief   Bootloader wrapper header.
+ *
+ * @addtogroup aos_bootloader
+ * @{
+ */
+
+#ifndef AMIROOS_BOOTLOADER_H
+#define AMIROOS_BOOTLOADER_H
+
+#include <amiroos.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Identifier for the case that no bootloader is installed/available.
+ */
+#define AOS_BOOTLOADER_NONE                     0
+
+/**
+ * @brief   Identifier for AMiRo-BLT
+ * @note    The version of the installed AMiRo-BLT can be retreived via the AMiRo-BLT interface.
+ */
+#define AOS_BOOTLOADER_AMiRoBLT                 1
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+#if (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT)
+#include <amiroblt.h>
+#endif
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+#if (AMIROOS_CFG_BOOTLOADER != AOS_BOOTLOADER_NONE) &&                        \
+    (AMIROOS_CFG_BOOTLOADER != AOS_BOOTLOADER_AMiRoBLT)
+  #error "AMIROOS_CFG_BOOTLOADER set to invalid value in aosconf.h"
+#endif
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* AMIROOS_BOOTLOADER_H */
+
+/** @} */
diff --git a/bootloader/bootloader.mk b/bootloader/bootloader.mk
index 7df00f0..e4104cb 100644
--- a/bootloader/bootloader.mk
+++ b/bootloader/bootloader.mk
@@ -30,7 +30,8 @@ AMIROOS_BOOTLOADER_DIR := $(dir $(lastword $(MAKEFILE_LIST)))
 AMIROBLT := $(AMIROOS_BOOTLOADER_DIR)AMiRo-BLT
 
 # include paths
-AMIROOS_BOOTLOADER_INC = $(AMIROBLT)/Target/Source/AMiRo
+AMIROOS_BOOTLOADER_INC = $(AMIROOS_BOOTLOADER_DIR) \
+                         $(AMIROBLT)/Target/Source/AMiRo
 
 # load module ID constants
 include $(AMIROBLT)/Target/Modules/moduleids.mk
diff --git a/core/inc/aos_confcheck.h b/core/inc/aos_confcheck.h
index 5f9f5f1..1dde0cb 100644
--- a/core/inc/aos_confcheck.h
+++ b/core/inc/aos_confcheck.h
@@ -59,13 +59,51 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
   #error "AMIROOS_CFG_MAIN_LOOP_TIMEOUT not defined in aosconf.h"
 #endif /* !defined(AMIROOS_CFG_MAIN_LOOP_TIMEOUT) */
 
+/* bootloader parameters and options */
+
+#if !defined(AMIROOS_CFG_BOOTLOADER)
+  #error "AMIROOS_CFG_BOOTLOADER not defined in aosconf.h"
+#endif /* !defined(AMIROOS_CFG_BOOTLOADER)*/
+
 /* SSSP parameters and options */
 
 #if !defined(AMIROOS_CFG_SSSP_ENABLE)
   #error "AMIROOS_CFG_SSSP_ENABLE not defined in aosconf.h"
 #endif /* !defined(AMIROOS_CFG_SSSP_ENABLE) */
 
-# if (AMIROOS_CFG_SSSP_ENABLE == true)
+#if (AMIROOS_CFG_SSSP_ENABLE == true)
+
+  #if !defined(AMIROOS_CFG_SSSP_STARTUP)
+    #error "AMIROOS_CFG_SSSP_STARTUP not defined in aosconf.h"
+  #else /* !defined(AMIROOS_CFG_SSSP_STARTUP) */
+    #if (AMIROOS_CFG_SSSP_STARTUP == true)
+      #if (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT)
+        #error "AMIROOS_CFG_SSSP_STARTUP is enabled in aosconf.h, but SSSP startup phase is already handled by AMiRo-BLT."
+      #endif /* (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT) */
+    #else /* (AMIROOS_CFG_SSSP_STARTUP == true) */
+      #if (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_NONE)
+        #error "AMIROOS_CFG_SSSP_STARTUP is disabled in aosconf.h, but no bootloader is defined to handle SSSP startup phase instead."
+      #endif /* (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_NONE) */
+    #endif /* (AMIROOS_CFG_SSSP_STARTUP == true) */
+  #endif /* !defined(AMIROOS_CFG_SSSP_STARTUP) */
+
+  #if !defined(AMIROOS_CFG_SSSP_SHUTDOWN)
+    #error "AMIROOS_CFG_SSSP_SHUTDOWN not defined in aosconf.h"
+  #else /* !defined(AMIROOS_CFG_SSSP_SHUTDOWN) */
+    #if (AMIROOS_CFG_SSSP_SHUTDOWN != true)
+      #if (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_NONE)
+        #error "AMIROOS_CFG_SSSP_SHUTDOWN is disabled in aosconf.h, but no bootloader is defined to handle SSSP shutdown phase instead."
+      #endif /* (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_NONE) */
+    #endif /* (AMIROOS_CFG_SSSP_SHUTDOWN != true) && (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_NONE) */
+  #endif /* !defined(AMIROOS_CFG_SSSP_SHUTDOWN) */
+
+  #if !defined(AMIROOS_CFG_SSSP_MSI)
+    #error "AMIROOS_CFG_SSSP_MSI not defined in aosconf.h"
+  #endif /* !defined(AMIROOS_CFG_SSSP_MSI) */
+
+  #if !defined(AMIROOS_CFG_SSSP_MODULEIDWIDTH)
+    #error "AMIROOS_CFG_SSSP_MODULEIDWIDTH not defined in aosconf.h"
+  #endif /* !defined(AMIROOS_CFG_SSSP_MODULEIDWIDTH) */
 
   #if !defined(AMIROOS_CFG_SSSP_MASTER)
     #error "AMIROOS_CFG_SSSP_MASTER not defined in aosconf.h"
@@ -94,6 +132,12 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
     #error "AMIROOS_CFG_SSSP_SYSSYNCPERIOD not defined in aosconf.h"
   #endif /* !defined(AMIROOS_CFG_SSSP_SYSSYNCPERIOD) */
 
+#else /* (AMIROOS_CFG_SSSP_ENABLE == true) */
+
+  #if (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT)
+    #warning "SSSP is disabled in aosconf.h, but AMiRo-BLT implements it nevertheless."
+  #endif /* (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT) */
+
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
 /* system shell options */
@@ -123,7 +167,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #else /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 
   #if (AMIROOS_CFG_TESTS_ENABLE == true)
-    #pragma message "AMiRo-OS shell enabled implicitely via AMIROOS_CFG_TESTS_ENABLE"
+    #error "Enabling AMIROOS_CFG_TESTS_ENABLE in aosconf.h requires AMIROOS_CFG_SHELL_ENABLE to be enabled as well."
   #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 
 #endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
diff --git a/core/inc/aos_shell.h b/core/inc/aos_shell.h
index b54f46b..901eb5a 100644
--- a/core/inc/aos_shell.h
+++ b/core/inc/aos_shell.h
@@ -29,7 +29,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 #include <amiroos.h>
 
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true)
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 
 /******************************************************************************/
 /* CONSTANTS                                                                  */
@@ -418,7 +418,7 @@ extern "C" {
 /* INLINE FUNCTIONS                                                           */
 /******************************************************************************/
 
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 
 #endif /* AMIROOS_SHELL_H */
 
diff --git a/core/inc/aos_sssp.h b/core/inc/aos_sssp.h
new file mode 100644
index 0000000..5a729da
--- /dev/null
+++ b/core/inc/aos_sssp.h
@@ -0,0 +1,181 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+/**
+ * @file    aos_sssp.h
+ * @brief   SSSP related macros, structures and functions.
+ *
+ * @addtogroup aos_sssp
+ * @{
+ */
+
+#ifndef AMIROOS_SSSP_H
+#define AMIROOS_SSSP_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Major version of the implemented SSSP.
+ */
+#define AOS_SSSP_VERSION_MAJOR                  1
+
+/**
+ * @brief   Minor version of the implemented SSSP.
+ */
+#define AOS_SSSP_VERSION_MINOR                  4
+
+/**
+ * @brief   Time of delays in microseconds.
+ */
+#define AOS_SSSP_DELAY                          AMIROOS_CFG_SSSP_SIGNALDELAY
+
+/**
+ * @brief   Timeout delay in microseconds according to SSSP.
+ * @details SSSP 1.x defines timeouts to be ten times longer than the signal delay time.
+ */
+#define AOS_SSSP_TIMEOUT                        (10 * AOS_SSSP_DELAY)
+
+/**
+ * @brief   Value to indicate an invalid module ID.
+ */
+#define AOS_SSSP_MODULEID_INVALID               ((aos_ssspmoduleid_t)0)
+
+/**
+ * @brief   Value for broadcasting, adressing all modules.
+ * @note    This value is identical to @p AOS_SSSP_MODULEID_INVALID since in the case that no module IDs were applied, addressing of specific modules is not possible, thus every communication would be a broadcast.
+ */
+#define AOS_SSSP_MODULEID_BROADCAST             ((aos_ssspmoduleid_t)0)
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+#if (AMIROOS_CFG_SSSP_MSI == true)
+  #error "SSSP module stack initialization (MSI not implemented yet"
+#endif
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Enumeration of the several stages of SSSP.
+ */
+typedef enum {
+  AOS_SSSP_STAGE_UNDEFINED    = 0x0000, /**< Identifier of yet undefined stage variable.  */
+  AOS_SSSP_STAGE_STARTUP      = 0x1000, /**< Identifier of SSSP startup phase.            */
+  AOS_SSSP_STAGE_STARTUP_1    = 0x1100, /**< Identifier of SSSP startup phase stage 1.    */
+  AOS_SSSP_STAGE_STARTUP_1_1  = 0x1110, /**< Identifier of SSSP startup phase stage 1-1.  */
+  AOS_SSSP_STAGE_STARTUP_1_2  = 0x1120, /**< Identifier of SSSP startup phase stage 1-2.  */
+  AOS_SSSP_STAGE_STARTUP_1_3  = 0x1130, /**< Identifier of SSSP startup phase stage 1-3.  */
+  AOS_SSSP_STAGE_STARTUP_2    = 0x1200, /**< Identifier of SSSP startup phase stage 2.    */
+  AOS_SSSP_STAGE_STARTUP_2_1  = 0x1210, /**< Identifier of SSSP startup phase stage 2-1.  */
+  AOS_SSSP_STAGE_STARTUP_2_2  = 0x1220, /**< Identifier of SSSP startup phase stage 2-2.  */
+  AOS_SSSP_STAGE_STARTUP_3    = 0x1300, /**< Identifier of SSSP startup phase stage 3.    */
+  AOS_SSSP_STAGE_STARTUP_3_1  = 0x1310, /**< Identifier of SSSP startup phase stage 3-1.  */
+  AOS_SSSP_STAGE_STARTUP_3_2  = 0x1320, /**< Identifier of SSSP startup phase stage 3-2.  */
+  AOS_SSSP_STAGE_STARTUP_3_3  = 0x1330, /**< Identifier of SSSP startup phase stage 3-3.  */
+  AOS_SSSP_STAGE_STARTUP_3_4  = 0x1340, /**< Identifier of SSSP startup phase stage 3-4.  */
+  AOS_SSSP_STAGE_OPERATION    = 0x2000, /**< Identifier of SSSP operation pahse.          */
+  AOS_SSSP_STAGE_SHUTDOWN     = 0x3000, /**< Identifier of SSSP shutdown phase.           */
+  AOS_SSSP_STAGE_SHUTDOWN_1   = 0x3100, /**< Identifier of SSSP shutdown phase stage 1.   */
+  AOS_SSSP_STAGE_SHUTDOWN_1_1 = 0x3110, /**< Identifier of SSSP shutdown phase stage 1-1. */
+  AOS_SSSP_STAGE_SHUTDOWN_1_2 = 0x3120, /**< Identifier of SSSP shutdown phase stage 1-2. */
+  AOS_SSSP_STAGE_SHUTDOWN_1_3 = 0x3130, /**< Identifier of SSSP shutdown phase stage 1-3. */
+  AOS_SSSP_STAGE_SHUTDOWN_2   = 0x3200, /**< Identifier of SSSP shutdown phase stage 2.   */
+  AOS_SSSP_STAGE_SHUTDOWN_2_1 = 0x3210, /**< Identifier of SSSP shutdown phase stage 2-1. */
+  AOS_SSSP_STAGE_SHUTDOWN_2_2 = 0x3220, /**< Identifier of SSSP shutdown phase stage 2-2. */
+  AOS_SSSP_STAGE_SHUTDOWN_2_3 = 0x3230, /**< Identifier of SSSP shutdown phase stage 2-3. */
+} aos_ssspstage_t;
+
+/**
+ * @brief   Type to represent module IDs.
+ */
+#if (AMIROOS_CFG_SSSP_MODULEIDWIDTH == 8)
+typedef uint8_t aos_ssspmoduleid_t;
+#elif (AMIROOS_CFG_SSSP_MODULEIDWIDTH == 16) || defined(__DOXYGEN__)
+typedef uint16_t aos_ssspmoduleid_t;
+#elif (AMIROOS_CFG_SSSP_MODULEIDWIDTH == 32)
+typedef uint32_t aos_ssspmoduleid_t;
+#else
+#error "AMIROOS_CFG_SSSP_MODULEIDWIDTH set to an invalid value."
+#endif
+
+/**
+ * @brief   Data structure holding module-wide SSSP information.
+ */
+typedef struct {
+  /**
+   * @brief   Current execution stage of SSSP.
+   */
+  aos_ssspstage_t stage;
+
+#if (AMIROOS_CFG_SSSP_MSI == true) || defined(__DOXYGEN__)
+
+  /**
+   * @brief   Module identifier.
+   * @details A value of @p AOS_SSSP_MODULEID_INVALID indicates an uninitialized ID.
+   *          The values @p AOS_SSSP_MODULEID_INVALID and @p AOS_SSSP_MODULEID_ALL are reserved and must not be set.
+   */
+  aos_ssspmoduleid_t moduleId;
+
+#endif /* (AMIROOS_CFG_SSSP_MSI == true) */
+
+} aos_ssspdata_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  void aosSsspInit(void);
+  aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, eventmask_t mask, eventmask_t* received);
+  void aosSsspShutdownInit(void);
+#if (AMIROOS_CFG_SSSP_SHUTDOWN == true) || defined(__DOXYGEN__)
+  void aosSsspShutdownBroadcastIdentifier(unsigned int identifier);
+  eventmask_t aosSsspShutdownWaitForIdentifierPulse(event_listener_t* gpiolistener, eventflags_t sflags, eventmask_t timermask, unsigned int* identifier);
+#endif /* (AMIROOS_CFG_SSSP_SHUTDOWN == true) */
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
+
+#endif /* AMIROOS_SSSP_H */
+
+/** @} */
diff --git a/core/inc/aos_system.h b/core/inc/aos_system.h
index 890a91a..e2d77b6 100644
--- a/core/inc/aos_system.h
+++ b/core/inc/aos_system.h
@@ -40,49 +40,34 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define AOS_SYSTEM_TIME_RESOLUTION              ((MICROSECONDS_PER_SECOND + CH_CFG_ST_FREQUENCY - 1) / CH_CFG_ST_FREQUENCY)
 
 /**
- * @brief   System event flag which is emitted when a shutdown was initiated.
+ * @brief   System event flag mask for shutdown related events.
  */
-#define AOS_SYSTEM_EVENTFLAGS_SHUTDOWN          (eventflags_t)(1 << 0)
+#define AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_MASK     ((eventflags_t)0x1F)
+
+/**
+ * @brief   System event flag which is emitted when a passive shutdown was initiated.
+ */
+#define AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_PASSIVE  ((eventflags_t)(1 << 0))
 
 /**
  * @brief   System event flag which is emitted when a shutdown to transportation mode was initiated.
  */
-#define AOS_SYSTEM_EVENTFLAGS_TRANSPORTATION    (AOS_SYSTEM_EVENTFLAGS_SHUTDOWN | (eventflags_t)(1 << 1))
+#define AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_TRANSPORTATION ((eventflags_t)(1 << 1))
 
 /**
  * @brief   System event flag which is emitted when a shutdown to deepsleep mode was initiated.
  */
-#define AOS_SYSTEM_EVENTFLAGS_DEEPSLEEP         (AOS_SYSTEM_EVENTFLAGS_SHUTDOWN | (eventflags_t)(1 << 2))
+#define AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_DEEPSLEEP ((eventflags_t)(1 << 2))
 
 /**
  * @brief   System event flag which is emitted when a shutdown to hibernate mode was initiated.
  */
-#define AOS_SYSTEM_EVENTFLAGS_HIBERNATE         (AOS_SYSTEM_EVENTFLAGS_SHUTDOWN | (eventflags_t)(1 << 3))
+#define AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_HIBERNATE ((eventflags_t)(1 << 3))
 
 /**
  * @brief   System event flag which is emitted when a system restart was initiated.
  */
-#define AOS_SYSTEM_EVENTFLAGS_RESTART           (AOS_SYSTEM_EVENTFLAGS_SHUTDOWN | (eventflags_t)(1 << 4))
-
-#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
-
-/**
- * @brief   Major version of the implemented SSSP.
- */
-#define AOS_SYSTEM_SSSP_VERSION_MAJOR           1
-
-/**
- * @brief   Minor version of the implemented SSSP.
- */
-#define AOS_SYSTEM_SSSP_VERSION_MINOR           4
-
-/**
- * @brief   Timeout delay according to SSSP.
- * @details SSSP defines timeouts to be ten times longer than the signal delay time.
- */
-#define AOS_SYSTEM_SSSP_TIMEOUT                 (10 * AMIROOS_CFG_SSSP_SIGNALDELAY)
-
-#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
+#define AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_RESTART ((eventflags_t)(1 << 4))
 
 /******************************************************************************/
 /* SETTINGS                                                                   */
@@ -101,66 +86,24 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 typedef enum aos_shutdown {
   AOS_SHUTDOWN_NONE,            /**< Default value if no shutdown action was initiated */
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
   AOS_SHUTDOWN_PASSIVE,         /**< Passive shutdown (initiated by another module). */
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
+#if (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_NONE) || defined (__DOXYGEN__)
+  AOS_SHUTDOWN_ACTIVE,          /**< Active shutdown. */
+#endif /* (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_NONE) */
+#if (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT) || defined (__DOXYGEN__)
   AOS_SHUTDOWN_HIBERNATE,       /**< Active shutdown to hibernate mode. */
   AOS_SHUTDOWN_DEEPSLEEP,       /**< Active shutdown to deepsleep mode. */
   AOS_SHUTDOWN_TRANSPORTATION,  /**< Active shutdown to transportation mode. */
   AOS_SHUTDOWN_RESTART,         /**< Active saystem restart request. */
+#endif /* (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT) */
 } aos_shutdown_t;
 
-#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
-
-/**
- * @brief   Enumerator of the several stages of SSSP.
- */
-typedef enum aos_ssspstage {
-  AOS_SSSP_STARTUP_1_1  = 0x10, /**< Identifier of SSSP startup phase stage 1-1. */
-  AOS_SSSP_STARTUP_1_2  = 0x11, /**< Identifier of SSSP startup phase stage 1-2. */
-  AOS_SSSP_STARTUP_1_3  = 0x12, /**< Identifier of SSSP startup phase stage 1-3. */
-  AOS_SSSP_STARTUP_2_1  = 0x14, /**< Identifier of SSSP startup phase stage 2-1. */
-  AOS_SSSP_STARTUP_2_2  = 0x15, /**< Identifier of SSSP startup phase stage 2-2. */
-  AOS_SSSP_STARTUP_3_1  = 0x18, /**< Identifier of SSSP startup phase stage 3-1. */
-  AOS_SSSP_STARTUP_3_2  = 0x19, /**< Identifier of SSSP startup phase stage 3-2. */
-  AOS_SSSP_STARTUP_3_3  = 0x1A, /**< Identifier of SSSP startup phase stage 3-3. */
-  AOS_SSSP_STARTUP_3_4  = 0x1B, /**< Identifier of SSSP startup phase stage 3-4. */
-  AOS_SSSP_OPERATION    = 0x20, /**< Identifier of SSSP operation pahse. */
-  AOS_SSSP_SHUTDOWN_1_1 = 0x30, /**< Identifier of SSSP shutdown phase stage 1-1. */
-  AOS_SSSP_SHUTDOWN_1_2 = 0x31, /**< Identifier of SSSP shutdown phase stage 1-2. */
-  AOS_SSSP_SHUTDOWN_1_3 = 0x32, /**< Identifier of SSSP shutdown phase stage 1-3. */
-  AOS_SSSP_SHUTDOWN_2_1 = 0x34, /**< Identifier of SSSP shutdown phase stage 2-1. */
-  AOS_SSSP_SHUTDOWN_2_2 = 0x35, /**< Identifier of SSSP shutdown phase stage 2-2. */
-  AOS_SSSP_SHUTDOWN_3   = 0x38, /**< Identifier of SSSP shutdown phase stage 3. */
-} aos_ssspstage_t;
-
-/**
- * @brief   Type to represent module IDs.
- */
-typedef uint16_t aos_ssspmoduleid_t;
-
-#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
-
 /**
  * @brief   AMiRo-OS base system structure.
  */
 typedef struct aos_system {
-#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
-  /**
-   * @brief   SSSP relevant data.
-   */
-  struct {
-    /**
-     * @brief   Current SSSP stage of the system.
-     */
-    aos_ssspstage_t stage;
-
-    /**
-     * @brief   Module identifier.
-     * @details A value of 0 indicates an uninitialized ID.
-     *          The vlaues 0 and ~0 are reserved und must not be set.
-     */
-    aos_ssspmoduleid_t moduleId;
-  } sssp;
-#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
   /**
    * @brief   System I/O stream.
@@ -173,9 +116,9 @@ typedef struct aos_system {
   struct {
 
     /**
-     * @brief   I/O event source.
+     * @brief   GPIO event source.
      */
-    event_source_t io;
+    event_source_t gpio;
 
     /**
      * @brief   OS event source.
@@ -183,14 +126,23 @@ typedef struct aos_system {
     event_source_t os;
   } events;
 
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 
   /**
    * @brief   Pointer to the shell object.
    */
   aos_shell_t shell;
 
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
+
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
+
+  /**
+   * @brief   SSSP relevant data.
+   */
+  aos_ssspdata_t sssp;
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
 } aos_system_t;
 
@@ -217,25 +169,29 @@ extern aos_system_t aos;
 #if defined(__cplusplus)
 extern "C" {
 #endif /* defined(__cplusplus) */
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true)
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
   void aosSysInit(const char* shellPrompt);
-#else /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#else /* (AMIROOS_CFG_SHELL_ENABLE == true) */
   void aosSysInit(void);
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
   void aosSysStart(void);
 #if (AMIROOS_CFG_SSSP_ENABLE == true) || defined (__DOXYGEN__)
-  eventmask_t aosSysSsspStartupOsInitSyncCheck(event_listener_t* syncEvtListener);
+  void aosSysStartUptime(void);
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
   void aosSysGetUptimeX(aos_timestamp_t* ut);
-#if (HAL_USE_RTC == TRUE)
+#if (HAL_USE_RTC == TRUE) || defined(__DOXYGEN__)
   void aosSysGetDateTime(struct tm* dt);
   void aosSysSetDateTime(struct tm* dt);
 #endif /* (HAL_USE_RTC == TRUE) */
   void aosSysShutdownInit(aos_shutdown_t shutdown);
   void aosSysStop(void);
   void aosSysDeinit(void);
-  void aosSysShutdownFinal(aos_shutdown_t shutdown);
-  palcallback_t aosSysGetStdExtiCallback(void);
+#if ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_SHUTDOWN != true)) ||               \
+    ((AMIROOS_CFG_SSSP_ENABLE != true) && (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT)) || \
+    defined(__DOXYGEN__)
+  void aosSysShutdownToBootloader(aos_shutdown_t shutdown);
+#endif /* ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_SHUTDOWN != true)) || ((AMIROOS_CFG_SSSP_ENABLE != true) && (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT)) */
+  palcallback_t aosSysGetStdGpioCallback(void);
 #if defined(__cplusplus)
 }
 #endif /* defined(__cplusplus) */
diff --git a/core/inc/aos_thread.h b/core/inc/aos_thread.h
index 4a1946d..a81e12e 100644
--- a/core/inc/aos_thread.h
+++ b/core/inc/aos_thread.h
@@ -122,7 +122,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 extern "C" {
 #endif /* defined(_cplusplus) */
   void aosThdSleepUntilS(const aos_timestamp_t t);
-#if (AMIROOS_CFG_DBG == true) && (CH_DBG_FILL_THREADS == TRUE)
+#if ((AMIROOS_CFG_DBG == true) && (CH_DBG_FILL_THREADS == TRUE)) || defined(__DOXYGEN__)
   size_t aosThdGetStackPeakUtilization(thread_t* thread);
 #endif /* (AMIROOS_CFG_DBG == true) && (CH_DBG_FILL_THREADS == TRUE) */
 #if defined(__cplusplus)
diff --git a/core/inc/aos_types.h b/core/inc/aos_types.h
index f0546d5..c934a54 100644
--- a/core/inc/aos_types.h
+++ b/core/inc/aos_types.h
@@ -87,7 +87,7 @@ typedef uint8_t aos_status_t;
 /**
  * @brief   Converts a GPIO pad number to a unique event flag.
  */
-#define AOS_IOEVENT_FLAG(pad)                   ((eventflags_t)1 << pad)
+#define AOS_GPIOEVENT_FLAG(pad)                 ((eventflags_t)1 << pad)
 
 /******************************************************************************/
 /* EXTERN DECLARATIONS                                                        */
